const { EmbedBuilder, ApplicationCommandOptionType, AttachmentBuilder } = require("discord.js");
const { EMBED_COLORS } = require("@root/config");

// This dummy token will be replaced by the actual token
const DUMMY_TOKEN = "MY_TOKEN_IS_SECRET";

const AsyncFunctionConstructor = (async() => {}).constructor
let prev = null
let store = Object.create(null)

/**
 * @type {import("@structures/Command")}
 */
module.exports = {
  name: "eval",
  description: "evaluates something",
  category: "OWNER",
  botPermissions: ["EmbedLinks"],
  command: {
    enabled: process.env.DEV === 'true',
    usage: "<script>",
    minArgsCount: 1,
  },
  slashCommand: {
    enabled: process.env.DEV === 'true',
    options: [
      {
        name: "expression",
        description: "Code to evaluate",
        type: ApplicationCommandOptionType.String,
        required: false,
      },
      {
        name: "attachment",
        description: "Code to evaluate",
        type: ApplicationCommandOptionType.Attachment,
        required: false,
      },
      {
        name: "async",
        description: "Use async - requires return to retreive value",
        type: ApplicationCommandOptionType.Boolean,
        required: false
      }
    ],
  },

  async messageRun(message, args, data) {
    let content = message.content.slice(data.prefix.length + data.invoke.length).trim()

    if (content.startsWith('```')) {
      content = content.replace(/^```(js)?/, '')
      if (content.endsWith('```')) content = content.slice(0, -3)
    }
    else if (content.startsWith('``')) {
      content = content.slice(2, -2)
    }

    const attachment = message.attachments.at(0)

    await message.reply(await execute(false, attachment, content, { message, args, data }, message.client));
  },

  async interactionRun(interaction, data) {
    const attachment = interaction.options.getAttachment("attachment")
    const code = interaction.options.getString("expression")
    const useAsync = interaction.options.getBoolean("async") ?? false

    await interaction.followUp(await execute(useAsync, attachment, code, { interaction, data }, interaction.client));
  },
};

async function execute(useAsync, attachment, code, context, client) {
  if (!code) {
    if (!attachment) return "Specify code or attachment to run"
    if (attachment.contentType !== 'text/javascript') return "Attachment type must be JavaScript"

    const res = await fetch(attachment.url)
    if (!res.ok && !code) return "Failed to retreive attachment"
    code = await res.text()
  }

  Object.assign(context, {
    client,
    store: store,
    _: prev
  })

  try {
    const exec = useAsync
      ? new AsyncFunctionConstructor('ctx', `with (ctx) {${code}}; return "return not set"`)
      : new Function('ctx', `with (ctx) return eval(${JSON.stringify(code)})`)
    const output = await exec.call(client, context)

    prev = output
    return buildResponse(output, client);
  } catch (ex) {
    return buildResponse(ex, client, true);
  }
}

const buildResponse = (output, client, isError) => {
  // Token protection
  output = require("util").inspect(output, {
    maxArrayLength: 5,
    maxStringLength: 500,
    depth: 3
  }).replaceAll(client.token, DUMMY_TOKEN);

  // use file
  if (output.length > 200 || (output.match(/\n/g)?.length ?? 0) > 10) {
    const file = new AttachmentBuilder(Buffer.from(output), { name: 'output.js' })

    return {
      content: isError ? 'Error!' : 'Output:',
      files: [file]
    }
  }
  // use embed
  else {
    const embed = new EmbedBuilder()
      .setAuthor({ name: isError ? "📤 Error" : "📤 Output" })
      .setDescription("```js\n" + output + "\n```")
      .setColor(isError ? EMBED_COLORS.ERROR : EMBED_COLORS.SUCCESS)
      .setTimestamp(Date.now());

    return { embeds: [embed] }
  }
};
