const Queue = require("@src/database/schemas/Queue");
const { ActionRowBuilder, ButtonBuilder, ButtonStyle, EmbedBuilder } = require("discord.js");

module.exports = async (client, player) => {
    const guild = client.guilds.cache.get(player.guildId);
    if (!guild) return;

    await Queue.save(player)

    if (player.voiceChannelId) {
      await client.utils.setVoiceStatus(client, player.voiceChannelId, "");
    }

    const msg = player.get("message");
    if (msg && msg.deletable) {
      await msg.delete().catch(() => {});
    }

    // Send a message with a button to resume playback
    const channel = guild.channels.cache.get(player.textChannelId);
    if (channel) {
      const row = new ActionRowBuilder().addComponents(
        new ButtonBuilder()
          .setCustomId("resume")
          .setLabel("Resume Music")
          .setStyle(ButtonStyle.Primary)
      );

      await channel.safeSend({
        embeds: [
          new EmbedBuilder()
            .setColor(EMBED_COLORS.BOT_EMBED)
            .setDescription("The music has stopped due to a disconnection. You can resume it by clicking the button below.")
        ],
        components: [row]
      });
    }
  };