const { autoplayFunction } = require("@handlers/player");
const { MUSIC } = require("@root/config.js");
const Queue = require("@src/database/schemas/Queue");

module.exports = async (client, player, track) => {
  const guild = client.guilds.cache.get(player.guildId);
  if (!guild) return;

  if (player.volume > 100) {
    await player.setVolume(MUSIC.DEFAULT_VOLUME);
  }

  const msg = player.get("message");
  if (msg && msg.deletable) {
    await msg.delete().catch(() => {});
  }

  // Check if the current track was saved in the database
  const queueData = await Queue.findGuild(player)

  // Remove the current track from the database after it has been played
  if (queueData) {
    const updatedTracks = queueData.tracks.filter(t => t.uri !== track.info.uri);
    await Queue.model.updateOne(
      { guildId: player.guildId },
      { tracks: updatedTracks, currentTrack: null }
    );

    // If there are no more tracks left, consider cleaning up the database entry
    if (updatedTracks.length === 0) {
      await Queue.deleteGuild(player)
    }
  }

  if (player.get("autoplay") === true) {
    await autoplayFunction(client, track, player);
  }
};